'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = setValidityActionReducer;

var _actionTypes = require('../../action-types');

var _actionTypes2 = _interopRequireDefault(_actionTypes);

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

var _mapValues = require('../../utils/map-values');

var _mapValues2 = _interopRequireDefault(_mapValues);

var _inverse = require('../../utils/inverse');

var _inverse2 = _interopRequireDefault(_inverse);

var _updateField2 = require('../../utils/update-field');

var _updateField3 = _interopRequireDefault(_updateField2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function setValidityActionReducer(state, action, localPath) {
  var _updateField;

  if (action.type !== _actionTypes2.default.SET_VALIDITY && action.type !== _actionTypes2.default.SET_ERRORS) {
    return state;
  }

  var isErrors = action.type === _actionTypes2.default.SET_ERRORS;
  var validity = isErrors ? action.errors : action.validity;

  var inverseValidity = (0, _isPlainObject2.default)(validity) ? (0, _mapValues2.default)(validity, _inverse2.default) : !validity;

  return (0, _updateField3.default)(state, localPath, (_updateField = {}, _defineProperty(_updateField, isErrors ? 'errors' : 'validity', validity), _defineProperty(_updateField, isErrors ? 'validity' : 'errors', inverseValidity), _defineProperty(_updateField, 'validated', true), _updateField));
}